<?php 
	class mailer {
		public $body;
		public $subject;
		public $addressat;
		protected $headers;
		protected $smtpServer;
		protected $smtpPort = '25';
		protected $smtpUser;
		protected $smtpPass;
		protected $mailMethod = 'mail';
		public $templateName;

		function __construct() {
            global $Config;

			$this->smtpServer = $Config->smtpServer;
			$this->smtpPort = $Config->smtpPort;
			$this->smtpUser = $Config->smtpUser;
			$this->smtpPass = $Config->smtpPass;
			$this->mailMethod = $Config->mailMethod;
		}

		protected function socketMail($to, $from, $subject, $message, $server, $port, $login = "", $pass = "") {
            global $Config;
			$connect = fsockopen ($server, $port, $errno, $errstr, 30); 
			if(!$connect) {
				echo("Could not connect to smtp server on: $server , $port , $login , $pass");
			}
			fputs($connect, "HELO localhost\r\n"); 
			if($login != "" && $pass != "") {
				fputs($connect, "AUTH LOGIN\r\n");
				fputs($connect, base64_encode($login)."\r\n");
				fputs($connect, base64_encode($pass)."\r\n");
			}
			fputs($connect, "MAIL FROM: ".$from."\n"); 
			fputs($connect, "RCPT TO: ".$to."\n"); 
			fputs($connect, "DATA\r\n"); 
			fputs($connect, "Content-Type: ".$Config->mailFormat."; charset=".$Config->mailEncoding."\n");
			fputs($connect, "To: ".$to."\n"); 
			fputs($connect, "Subject: ".$subject."\n"); 
			fputs($connect, "\n\n"); 
			fputs($connect, $message." \r\n"); 
			fputs($connect, ".\r\n"); 
			fputs($connect, "RSET\r\n"); 
			unset($connect);
			if($errno == 0 OR !$errno) {
				Return true;
			}
			else {
				Return "<h1> Error  #" . $errno . " :: " . $errstr ."</h1>";
			}
		}

		protected function sendMail($addressat,$subject,$body) {
			Return mail($addressat,$subject,$body,$this->getHeaders());
		}

		protected function getHeaders() {
            global $Config;
			$this->headers = "Content-Type: ".$Config->mailFormat."; charset=".$Config->mailEncoding."\n";
			$this->headers .= "From: ".$Config->siteName." (".$Config->siteUrl.")\n";
			Return $this->headers;
		}

		public function send($addressat,$subject,$body) {
            global $Config;
			if($this->mailMethod == 'smtp') {
				Return $this->socketMail($addressat, $Config->siteName, $subject, $body, $this->smtpServer, $this->smtpPort, $this->smtpUser, $this->smtpPass);
			}
			else {
				Return $this->sendMail($addressat,$subject,$body);
			}
		}

		public function getMailBody($templateName, $replaceFrom = "", $replaceTo = "") {
            global $Config;
			$db = Toolkit::getInstance()->getDbInstance();
			$db->query("SELECT text,title FROM ".$Config->DbPrefix."mail_templates WHERE name='".$templateName."'");
			if($db->nrows() > 0) {
				$text = $db->fassoc();
				if(is_array($replaceFrom) && is_array($replaceTo)) {
					for($ii=0; $ii < sizeof($replaceFrom); $ii++) {
						$text['text'] = str_replace($replaceFrom[$ii], $replaceTo[$ii], $text['text']);
						$text['title'] = str_replace($replaceFrom[$ii], $replaceTo[$ii], $text['title']);
					}
				}
				
				Return $text;
			}
			else {
				Return false;
			}
			unset($db);
		}
	}
?>